Summary: Cobalt x86 kernel 
Name: kernel
Version: 2.2.16C27_V
%define version %{PACKAGE_VERSION}
Release: 4
Copyright: GPL/Cobalt
Group: Base/Kernel
ExclusiveOS: Linux
Source: cobalt-linux-%{version}.tar.gz
BuildRoot: /var/tmp/kernel

%changelog
* Mon Jun 11 2001 Tim Hockin <thockin@sun.com>
   - Fix conf.modules/modules.conf code to handle both existing
   - include hpt366 fixes for state machine resets (asun)
   - include ide fixes for buffer flushing (asun)
   - C27-4

* Tue May 22 2001 Tim Hockin <thockin@sun.com>
   - Add newest 2.2.16 USB backport
   - Fix WDT to reboot on CacheRaQ4 properly
   - C27
   
* Thu May 17 2001 Tim Hockin <thockin@sun.com>
   - Fix sym53c8xx timer handling
   - Fix non-static debug variable in cobalt_ssn.c
   - C26-3

* Wed May 16 2001 Tim Hockin <thockin@sun.com>
   - Fix typo (/dev/lcd2 instead of /dev/lcd) in specfile
   - C26-2

* Tue May 15 2001 Tim Hockin <thockin@sun.com>
   - incorporate sym53c8xxx.c __init fix
   - fix cobalt WDT for bootloader
   - C26-1

* Wed May 09 2001 Tim Hockin <thockin@sun.com>
   - cleanup in spec file to match 2.4.x advances

* Wed May 02 2001 Adrian Sun <a.sun@sun.com>
   - C25-2
   - just add a little ECC reporting for testing

* Fri Apr 27 2001 Tim Hockin <thockin@sun.com>
   - C24 went out without a log message
   - This is C25
   - Applied Uzi's first shot at breaking the kernel to fix ptrace() properly

* Tue Oct 10 2000 Duncan Laurie <duncan@cobalt.com>
   - build for raqXTR

* Mon Sep 18 2000 Chris Johnson <cjohnson@cobalt.com>
   - More cleanup on %post below.  Deal with stale kernels
     by assuming "Intel Unknown" means eepro100.
   - Minor tweaks to fix debugging/watchdog interaction
* Wed Sep 13 2000 Adrian Sun
   - build with chris' really fixed eepro driver. 

* Wed Sep 13 2000 Tim Hockin
   - Fixup %post shell boolean associativity
   - Only alias ethernet modules that are eepro100 or dp83815
   - Detect DP83815 or NS Unknown as dp83815

* Tue Sep 12 2000 Chris Johnson <cjohnson@cobalt.com>
   - New Eepro driver and interrupt model to fix network behaviour under
     heavy load
   - Enabled many USB modules - just in case.
   - Converted ethernet drivers to modules.  RPM specfile (below)
     ensures that /etc/conf.modules is correct.
   - Fixed pci list for Nat-Semi driver so it is no longer "Unknown"
     Fixed Nat-Semi driver to use (new) values from pci.h

* Mon Aug 21 2000 Adrian Sun <asun@cobalt.com>
  - reiserfs-3.5.24 integration.
  - make separate reiserfs util rpm.

* Fri Jun 23 2000 Tim Hockin <thockin@cobalt.com>
  - 2.2.16 merge

* Thu Jun 08 2000 Tim Hockin <thockin@cobalt.com>
  - 2.2.16 security fix for setuid
    (kernel/capability.c, include/linux/capability.h, fs/exec.c)

* Thu May 18 2000 Tim Hockin <thockin@cobalt.com>
  - 2.2.15 merge

* Wed May 10 2000 Tim Hockin <thockin@cobalt.com>
  - Merged National dp83815 enet driver plus support code plus fixes

* Thu Apr 6 2000 Chris Johnson <cjohnson@cobalt.com>
  - Merged in UDP IPMASQ fix from 2.2.15pre17

  - Merged in all small/obvious fixes from 2.2.15pre17
    Lots of lock cleanup and error edge conditions.

* Sun Mar 26 2000 Chris Johnson <cjohnson@cobalt.com>
 - Added enable/disable feature to watchdog for insmod to
   prevent long duration device initialization from resetting
   the system.

 - Added NAT related config flags.

 - Added "cobalt_install" target to makefile.  Use with caution.

* Mon Mar  6 2000 Chris Johnson <cjohnson@cobalt.com>
 - Minor tweaks for bandwidth management linking.
 - Supports kgdb patch.

* Thu Jan 13 2000 Tim Hockin <thockin@cobalt.com>
 - Lots of various fixes have gone in here - no one has updated this file
 - 2.2.14 merge
 - Added RAID0145 patch
 - Added RAID-wo patch
 - Added USB patch
 - added patches to unofficial-patches dir
 - Everyone should remember to update the kernel.spec.in for big changes
 
* Tue Oct 05 1999 Tim Hockin <thockin@cobaltnet.com>
 - Fix for WDT when booted from ROM or net

* Mon Oct 04 1999 Tim Hockin <thockin@cobaltnet.com>
 - Fixes for WDT
 - Temperature is now output in /proc/cpuinfo
 - bwmgmt fixes for tcpdump from Chris
 - make rpm is smarter about versions, now
 - fixed (workaround, really) bug on first read of LM77

* Sun Oct 03 1999 Tim Hockin <thockin@cobaltnet.com>

 - New boards will have a builtin PIC - use that so we can ditch the PIC
    - hopefully this code can be scrapped - it's ugly
 - Added test for 82559ER - do not use MMIO!

* Tue Sep 28 1999 Tim Hockin <thockin@cobaltnet.com>

 - New cobalt_temp driver - gives /proc/cpu_temperature
 - version cleanups
 - WDT cleanup/enable
 - minor LED cleanup

* Tue Sep 14 1999 Tim Hockin <thockin@cobaltnet.com>

 - LCD driver cleanup by asun
 - New cobalt_wdt driver
 - Various cleanups, fixes, etc

* Thu Aug 26 1999 Tim Hockin <thockin@cobaltnet.com>

 - Patched up to 2.2.12
 - Backed out UDMA and kgdb patches
 - Versioning changed to match mips style
 - Changed tarfile name for $Source

* Tue Aug 24 1999 Timothy Stonis <tim@cobaltnet.com>

 - Added BW management stuff... 
 - Fix date on last checkin.  

* Wed Aug 18 1999 Timothy Stonis <tim@cobaltnet.com>

 - Roll in fix to IP aliasing 

* Sun Aug 8 1999 Timothy Stonis <tim@cobaltnet.com>

 - initial creation of Intel 2.2 package

%package headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel

%package source
Requires: kernel-headers = %{version}
Summary: Kernel source tree
Group: Base/Kernel

%package reiserfs-utils
Summary: Reiserfs utilities
Group: System Environment/Base

%description
This package contains the Linux kernel and modules that are used to boot 
and run your system. The kernel contains a few device drivers for specific 
hardware, but most hardware is instead supported by modules loaded after 
booting.

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%description reiserfs-utils
This package contains all of the utilities needed by the reiserfs filesystem.

%prep
if [ "X" != "${RPM_BUILD_ROOT}X" ]; then
    rm -rf $RPM_BUILD_ROOT
fi

%setup -c -q
#setup the tree for the "installed" files - the source
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{version}
cd $RPM_BUILD_ROOT/usr/src
zcat $RPM_SOURCE_DIR/cobalt-linux-%{version}.tar.gz | tar -xf-

find linux-2.2 -name "*.orig" -print | xargs rm -f
mv linux-2.2 linux-%{version}
ln -sfn linux-%{version} linux
chown -R root.root linux-%{version}

%build
# build the actual kernel
cd linux-2.2
cat config-rpm > arch/i386/defconfig
# 'make rpm' leaves $CONFIGURATION around - bad news
[ -n "$CONFIGURATION" ] && unset CONFIGURATION
make oldconfig COBALT_GENERATION=_V
make dep clean COBALT_GENERATION=_V
make cobalt COBALT_GENERATION=_V
make modules COBALT_GENERATION=_V

# make the sources ready for inclusion in the RPM
cd $RPM_BUILD_ROOT/usr/src/linux-%{version}
cat config-rpm > arch/i386/defconfig
make oldconfig COBALT_GENERATION=_V
make include/linux/version.h COBALT_GENERATION=_V

%install
cd linux-2.2
mkdir -p $RPM_BUILD_ROOT/boot
cp vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinux-%{version}.gz
ln -sf /boot/vmlinux-%{version}.gz $RPM_BUILD_ROOT/boot/vmlinux.gz
cp System.map $RPM_BUILD_ROOT/boot/System-%{version}.map
ln -sf /boot/System-%{version}.map $RPM_BUILD_ROOT/boot/System.map
cp vmlinux.gz $RPM_BUILD_ROOT/vmlinux-%{version}.gz
ln -sf /vmlinux-%{version}.gz $RPM_BUILD_ROOT/vmlinux.gz
make modules_install INSTALL_MOD_PATH=$RPM_BUILD_ROOT \
	COBALT_GENERATION=_V

# reiserfs
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/usr/man/man8
(cd fs/reiserfs/utils; make CC=gcc; make install CC=gcc SBIN=$RPM_BUILD_ROOT/sbin MANDIR=$RPM_BUILD_ROOT/usr/man/man8)

mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
ln -s ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux

%clean
rm -rf $RPM_BUILD_ROOT

%pre
if [ ! -f /usr/games/.doug ] ; then
    if [ -f /boot/vmlinux.gz ] ; then
	mkdir -p /usr/games
	cp /boot/vmlinux.gz /usr/games/.doug
    fi
fi

%post
if [ ! -f /usr/games/.doug ] ; then
    mkdir -p /usr/games
    cp /boot/vmlinux.gz /usr/games/.doug
fi

CONF_FILE=/etc/modules.conf
if [ -f /etc/conf.modules -a ! -f /etc/modules.conf ] ; then
    CONF_FILE=/etc/conf.modules
fi

if [ ! -f $CONF_FILE ] || [ -z "`grep eth0 $CONF_FILE 2>/dev/null`" ] ; then
	awk ' /Bus/   { getline ;
			if ($1 == "Ethernet") {
			    etype=0;
			    if (($4 ~ "8255[789].*") || 
			     ($3 ~ "Intel" && $4 ~ "Unknown")) {
				etype="eepro100";
			    } else if (($0 ~ "83815") ||
			     ($3 ~ "NS" && $4 ~ "Unknown")) {
				etype="dp83815";
			    }   
			    if (etype) {
			    	printf "alias eth%d %s\n", ethnum, etype;
			    }
			    ethnum++;
			    if (ethnum > 1)
				exit
			}       
		} ' < /proc/pci >> $CONF_FILE
fi

# re-create /dev/lcd with the expected device number
rm -f /dev/lcd
mknod /dev/lcd c 10 140

%files
/boot/vmlinux-%{version}.gz
/boot/vmlinux.gz
/boot/System-%{version}.map
/boot/System.map
/vmlinux-%{version}.gz
/vmlinux.gz
%dir /usr/src/linux-%{version}
/usr/src/linux
%dir /lib/modules
/lib/modules/%{version}

%files source
%dir /usr/src/linux-%{version}
/usr/src/linux-%{version}/.config
/usr/src/linux-%{version}/COPYING
/usr/src/linux-%{version}/CREDITS
/usr/src/linux-%{version}/Documentation
/usr/src/linux-%{version}/MAINTAINERS
/usr/src/linux-%{version}/Makefile
/usr/src/linux-%{version}/README
/usr/src/linux-%{version}/Rules.make
/usr/src/linux-%{version}/arch
/usr/src/linux-%{version}/drivers
/usr/src/linux-%{version}/fs
/usr/src/linux-%{version}/init
/usr/src/linux-%{version}/ipc
/usr/src/linux-%{version}/kernel
/usr/src/linux-%{version}/lib
/usr/src/linux-%{version}/mm
/usr/src/linux-%{version}/modules
/usr/src/linux-%{version}/net
/usr/src/linux-%{version}/scripts

%files headers
%dir /usr/src/linux-%{version}
/usr/src/linux-%{version}/include/asm
/usr/src/linux-%{version}/include/asm-generic
/usr/src/linux-%{version}/include/linux
/usr/src/linux-%{version}/include/net
/usr/src/linux-%{version}/include/scsi
/usr/include/asm
/usr/include/linux
/usr/src/linux-%{version}/include/asm-i386

%files reiserfs-utils
/sbin/mkreiserfs
/sbin/reiserfsck
/sbin/resize_reiserfs
%doc /usr/man/man8/mkreiserfs.8.gz
%doc /usr/man/man8/reiserfsck.8.gz
